#include <HX711.h>

#include "HX711.h"

// HX711 circuit wiring
const int DT_Pin = 2;
const int SCK_Pin = 3;
unsigned long Count = 0;  // Record the digital signal
int i, j; 
char val = '0';

void setup() {
  Serial.begin(57600);
  pinMode(SCK_Pin, OUTPUT);
  pinMode(DT_Pin, INPUT_PULLUP);
}

// Function for reading the digital signal
unsigned long ReadCount() {

  // Clock set to LOW
  digitalWrite(SCK_Pin, LOW); 

  // Generate clock signal until DT becomes LOW
  while (digitalRead(DT_Pin) == HIGH) {
    continue;
    }

  // Read the digital signal every once in a clock cycle
  // with most-significant bit first (MSBFIRST) in order
  // Repeat the clock 24 times
  for (i = 0; i < 24; i++) { 
    digitalWrite(SCK_Pin, HIGH);
    delayMicroseconds(1); 
    Count = Count << 1; 
    digitalWrite(SCK_Pin, LOW); 
    delayMicroseconds(1);

    // Return the bit based on the state of DT
    Count = Count | digitalRead(DT_Pin);
  }

    // Perform an additional clock cycle
    // for a gain of 128 in channel A
  for (j = 0; j < 1; j++) {
    digitalWrite(SCK_Pin, HIGH);
    delayMicroseconds(1); 
    digitalWrite(SCK_Pin, LOW); 
    delayMicroseconds(1); 
    return(Count);
  }
}

void loop() {
  if (Serial.available()) { // If data is available to read,
    val = Serial.read(); // read it and store it in val
    if (val == '1') { // If 1 was received
      Count = ReadCount();
      Serial.write(Count & 0xFF); // Write low 8 bits
      Serial.write(Count >> 8); // Write middle 8 bits
      Serial.write(Count >> 16); // Write high 8 bits
      val = '0';
    }
  }
}
